<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Block;

use Magento\Framework\View\Element\Template;
use Semknox\Semknox\Helper\ConfigInterface;

/**
 * Class Seo
 *
 * SEO JavaScript control block
 *
 * @package Semknox\Semknox\Block
 */
class Seo extends Template
{

    /**
     * @var ConfigInterface
     */
    protected $config;

    /**
     * Seo constructor.
     *
     * @param Template\Context $context
     * @param ConfigInterface  $config
     * @param array            $data
     */
    public function __construct(
        Template\Context $context,
        ConfigInterface $config,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->config = $config;
    }

    /**
     * Returns '1' if SEO URLs are enabled, '0' otherwise.
     * @return string
     */
    public function isSeoEnabled()
    {
        return $this->config->getSeoUrlEnabled() ? '1' : '0';
    }

    /**
     * Returns the configured SEO prefix.
     * @return string
     */
    public function getSeoPrefix()
    {
        return $this->config->getSeoUrlPrefix();
    }
}
