<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library;

/**
 * Interface LibEntrypointInterface
 *
 * The entrypoint class for library communication that grants access to other functionality interfaces
 *
 * @package Semknox\Semknox\Library
 */
interface LibEntrypointInterface
{

    /**
     * @return LibAuthenticationInterface
     */
    public function auth();

    /**
     * @return LibFeaturesInterface
     */
    public function features();

    /**
     * @return LibSearchInterface
     */
    public function search();

    /**
     * @return LibUpdateInterface
     */
    public function update();
}
