<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library\SearchResult;

interface LibFilterInterface
{
    const FILTER_TYPE_SELECT = 'SELECT';
    const FILTER_TYPE_MULTI_SELECT = 'MULTI_SELECT';
    const FILTER_TYPE_RANGE = 'RANGE';

    /**
     * Get type of filter, which may be any of the FILTER_TYPE_* constants
     * @return mixed
     */
    public function getType();

    /**
     * Human-readable name of this filter attribute
     * @return string
     */
    public function getName();

    /**
     * Identifier / Attribute Code / Field Name of this filter
     * @return mixed
     */
    public function getId();

    /**
     * A list of possible options for this filter
     * @return LibFilterOptionInterface[]
     */
    public function getOptions();

    /**
     * Only if range filter:
     * Maximum value
     * @return mixed
     */
    public function getMax();

    /**
     * Only if range filter:
     * Minimum value
     * @return mixed
     */
    public function getMin();

    /**
     * Only if range filter:
     * Name of the unit controlled by this range filter
     * @return mixed
     */
    public function getUnitName();
}
