<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library\SearchResult;

/**
 * Class LibFilter
 *
 * Default implementations, implements this as a simple data object
 *
 * @package Semknox\Semknox\Library\SearchResult
 */
class LibFilterOption implements LibFilterOptionInterface
{

    /**
     * @var string
     */
    protected $name;

    /**
     * @var mixed
     */
    protected $id;

    /**
     * @var int
     */
    protected $count;

    /**
     * Human readable name of this filter option
     *
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Identifier of this option
     *
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Number of articles that have this option
     *
     * @return mixed
     */
    public function getCount()
    {
        return $this->count;
    }

    /**
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @param mixed $id
     * @return void
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @param int $count
     * @return void
     */
    public function setCount($count)
    {
        $this->count = $count;
    }
}
