<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Library\Semknox\Api\Data;

use Semknox\Semknox\Library\Semknox\Api\Data\Product\PriceInterface;

interface ProductInterface
{
    const VAR_NAME = 'name';
    const VAR_IMAGE = 'image';
    const VAR_ID = 'id';
    const VAR_LINK = 'link';
    const VAR_PRICE = 'price';

    /**
     * @return string
     */
    public function getName();

    /**
     * @return string
     */
    public function getImage();

    /**
     * @return string
     */
    public function getId();

    /**
     * @return string
     */
    public function getLink();

    /**
     * @return PriceInterface
     */
    public function getPrice();

    /**
     * @param string $name
     * @return mixed
     */
    public function setName($name);

    /**
     * @param string $image
     * @return mixed
     */
    public function setImage($image);

    /**
     * @param string $id
     * @return mixed
     */
    public function setId($id);

    /**
     * @param string $link
     * @return mixed
     */
    public function setLink($link);

    /**
     * @param PriceInterface $price
     * @return mixed
     */
    public function setPrice($price);
}
