<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Library\Semknox\Api\Data;

use Semknox\Semknox\Library\Semknox\Api\Data\Result\FilterInterface;
use Semknox\Semknox\Library\Semknox\Api\Data\Result\OrderInterface;

/**
 * Interface ProductsInterface
 *
 * This interface represents the API endpoint /products
 *
 * @package Semknox\Semknox\Library\Api\Query
 */

interface ProductsInterface
{
    const VAR_RESULTS = 'results';
    const VAR_ZERO_RESULTS = 'zero_results';
    const VAR_ORDERS = 'order';
    const VAR_RESULTS_INDEXED = 'results_indexed';
    const VAR_FILTERS = 'filters';

    /**
     * Returns the products as an array ordered by SSP
     * @return ResultInterface[]
     * @api
     */
    public function getResults();

    /**
     * Returns the products as an associative array where the keys are product ids.
     * @return ResultInterface []
     * @api
     */
    public function getResultsIndexed();

    /**
     * @return ResultInterface []
     * @api
     */
    public function getZeroResults();

    /**
     * @return OrderInterface[]
     * @api
     */
    public function getOrders();

    /**
     * @return FilterInterface[]
     * @api
     */
    public function getFilters();
}
