<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Library\Semknox\Api\Data\Result\Filter;

use Semknox\Semknox\Library\SearchResult\LibFilterOptionInterface;

interface OptionInterface
{
    const VAR_ID = 'id';
    const VAR_TEMPLATE_OPTION_ID = 'templateOptionId';
    const VAR_ICON = 'icon';
    const VAR_DEFAULT = 'default';
    const VAR_POSITION = 'position';
    const VAR_DELTA = 'delta';
    const VAR_COUNT = 'count';
    const VAR_VIEW_NAME = 'viewName';

    /**
     * @return int
     */
    public function getId();

    /**
     * @return int
     */
    public function getTemplateOptionId();

    /**
     * @return string
     */
    public function getIcon();

    /**
     * @return bool
     */
    public function getDefault();

    /**
     * @return int
     */
    public function getPosition();

    /**
     * @return int
     */
    public function getDelta();

    /**
     * @return int
     */
    public function getCount();

    /**
     * @return string
     */
    public function getViewName();

    /**
     * @param int $id
     * @return mixed
     */
    public function setId($id);

    /**
     * @param int $templateOptionId
     * @return mixed
     */
    public function setTemplateOptionId($templateOptionId);

    /**
     * @param int $icon
     * @return mixed
     */
    public function setIcon($icon);

    /**
     * @param bool $default
     * @return mixed
     */
    public function setDefault($default);

    /**
     * @param int $position
     * @return mixed
     */
    public function setPosition($position);

    /**
     * @param int $delta
     * @return mixed
     */
    public function setDelta($delta);

    /**
     * @param int $count
     * @return mixed
     */
    public function setCount($count);

    /**
     * @param string $viewName
     * @return mixed
     */
    public function setViewName($viewName);
}
