<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Library\Semknox\Api\Data\Result;

use Semknox\Semknox\Library\SearchResult\LibFilterInterface;

interface FilterInterface
{
    const VAR_ID = 'id';
    const VAR_VIEW_NAME = 'viewName';
    const VAR_CUSTOMER_ID = 'customerId';
    const VAR_POSITION = 'position';
    const VAR_UNIT_NAME = 'unitName';
    const VAR_TYPE = 'type';
    const VAR_SORT_TYPE = 'sortType';
    const VAR_LOGIC = 'logic';
    const VAR_TEMPLATE_FILTER_ID = 'templateFilterId';
    const VAR_FILLING_DEGREE = 'fillingDegree';
    const VAR_OPTION_COUNT = 'optionCount';
    const VAR_ACTIVATE_NEW_OPTIONS = 'activateNewOptions';
    const VAR_OPTIONS = 'options';
    const VAR_MIN = 'min';
    const VAR_MAX = 'max';
    const VAR_STEP = 'step';
    const VAR_ID_NAME = 'idName';

    /**
     * @return int
     */
    public function getId();

    /**
     * @return string
     */
    public function getViewName();

    /**
     * @return int
     */
    public function getCustomerId();

    /**
     * @return int
     */
    public function getPosition();

    /**
     * @return string
     */
    public function getUnitName();

    /**
     * @return string
     */
    public function getType();

    /**
     * @return string
     */
    public function getSortType();

    /**
     * @return string
     */
    public function getLogic();

    /**
     * @return int
     */
    public function getTemplateFilterId();

    /**
     * @return int
     */
    public function getFillingDegree();

    /**
     * @return int
     */
    public function getOptionCount();

    /**
     * @return bool
     */
    public function getActivateNewOptions();

    /**
     * @return string[]
     */
    public function getOptions();

    /**
     * @return Filter\OptionInterface[]
     */
    public function getOptionsObjects();

    /**
     * @return int
     */
    public function getMin();

    /**
     * @return int
     */
    public function getMax();

    /**
     * @return int
     */
    public function getStep();

    /**
     * @return string
     */
    public function getIdName();

    /**
     * @param int $id
     * @return mixed
     */
    public function setId($id);

    /**
     * @param string $viewName
     * @return mixed
     */
    public function setViewName($viewName);

    /**
     * @param string $customerId
     * @return mixed
     */
    public function setCustomerId($customerId);

    /**
     * @param string $position
     * @return mixed
     */
    public function setPosition($position);

    /**
     * @param string $unitName
     * @return mixed
     */
    public function setUnitName($unitName);

    /**
     * @param string $type
     * @return mixed
     */
    public function setType($type);

    /**
     * @param string $sortType
     * @return mixed
     */
    public function setSortType($sortType);

    /**
     * @param string $logic
     * @return mixed
     */
    public function setLogic($logic);

    /**
     * @param string $templateFilterId
     * @return mixed
     */
    public function setTemplateFilterId($templateFilterId);

    /**
     * @param string $fillingDegree
     * @return mixed
     */
    public function setFillingDegree($fillingDegree);

    /**
     * @param string $optionCount
     * @return mixed
     */
    public function setOptionCount($optionCount);

    /**
     * @param string $activateNewOptions
     * @return mixed
     */
    public function setActivateNewOptions($activateNewOptions);

    /**
     * @param string[] $options
     * @return mixed
     */
    public function setOptions($options);

    /**
     * @param string $min
     * @return mixed
     */
    public function setMin($min);

    /**
     * @param string $max
     * @return mixed
     */
    public function setMax($max);

    /**
     * @param string $step
     * @return mixed
     */
    public function setStep($step);

    /**
     * @param string $idName
     * @return mixed
     */
    public function setIdName($idName);
}
