<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Library\Semknox\Api\Data;

use Semknox\Semknox\Library\Semknox\Api\Data\Result\FlagInterface;

interface ResultInterface
{
    const VAR_ID = 'id';
    const VAR_GROUP_ID = 'groupId';
    const VAR_ARTICLE_NUMBER = 'articleNumber';
    const VAR_PROPERTIES = 'properties';
    const VAR_PASS_ON = 'passOn';
    const VAR_NAME = 'name';
    const VAR_IMAGE = 'image';
    const VAR_LINK = 'link';
    const VAR_FEATURE = 'featured';
    const VAR_HEAD = 'head';
    const VAR_FLAGS = 'flags';

    /**
     * @return int
     */
    public function getId();

    /**
     * @return int
     */
    public function getGroupId();

    /**
     * @return int
     */
    public function getArticleNumber();

    /**
     * @return string
     */
    public function getProperties();

    /**
     * @return string
     */
    public function getPassOn();

    /**
     * @return string
     */
    public function getName();

    /**
     * @return string
     */
    public function getImage();

    /**
     * @return string
     */
    public function getLink();

    /**
     * @return bool
     */
    public function getFeatured();

    /**
     * @return bool
     */
    public function getHead();

    /**
     * @return \Semknox\Semknox\Library\Semknox\Api\Data\Result\FlagInterface[]
     */
    public function getFlags();

    /**
     * @param int $id
     * @return mixed
     */
    public function setId($id);

    /**
     * @param int $groupId
     * @return mixed
     */
    public function setGroupId($groupId);

    /**
     * @param int $articleNumber
     * @return mixed
     */
    public function setArticleNumber($articleNumber);

    /**
     * @param mixed $properties
     * @return mixed
     */
    public function setProperties($properties);

    /**
     * @param mixed $passOn
     * @return mixed
     */
    public function setPassOn($passOn);

    /**
     * @param string $name
     * @return mixed
     */
    public function setName($name);

    /**
     * @param string $image
     * @return mixed
     */
    public function setImage($image);

    /**
     * @param string $link
     * @return mixed
     */
    public function setLink($link);

    /**
     * @param bool $featured
     * @return mixed
     */
    public function setFeatured($featured);

    /**
     * @param bool $head
     * @return mixed
     */
    public function setHead($head);

    /**
     * @param \Semknox\Semknox\Library\Semknox\Api\Data\Result\FlagInterface[] $flags
     * @return mixed
     */
    public function setFlags($flags);
}
