<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library\Semknox;

/**
 * Factory Class for ApiCommunicator
 *
 * @package Semknox\Semknox\Library
 */
class ApiCommunicatorFactory
{

    /**
     * Create a new ApiCommunicator
     *
     * @param ApiConfig $apiConfig An ApiConfig object containing the API username and API key.
     *
     * @return string
     * @api
     */
    public function create($apiConfig)
    {
        return new ApiCommunicator($apiConfig, new \Zend\Http\Client());
    }
}
