<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library\Semknox;

/**
 * Class ApiConfig
 *
 * A simple data wrapper for customer id, api key and api url
 *
 * @package Semknox\Semknox\Library
 */
class ApiConfig
{

    /**
     * @var mixed
     */
    protected $customerId;

    /**
     * @var mixed
     */
    protected $apiKey;

    /**
     * @var mixed
     */
    protected $apiUrl;

    /**
     * @var mixed
     */
    protected $searchBatchSize;

    /**
     * @return mixed
     */
    public function getCustomerId()
    {
        return $this->customerId;
    }

    /**
     * @return mixed
     */
    public function getApiKey()
    {
        return $this->apiKey;
    }

    /**
     * @param mixed $customerId
     * @return void
     */
    public function setCustomerId($customerId)
    {
        $this->customerId = $customerId;
    }

    /**
     * @param mixed $apiKey
     * @return void
     */
    public function setApiKey($apiKey)
    {
        $this->apiKey = $apiKey;
    }

    /**
     * @return mixed
     */
    public function getApiUrl()
    {
        return $this->apiUrl;
    }

    /**
     * @param mixed $apiUrl
     */
    public function setApiUrl($apiUrl)
    {
        $this->apiUrl = $apiUrl;
    }

    /**
     * @return mixed
     */
    public function getSearchBatchSize()
    {
        return $this->searchBatchSize;
    }

    /**
     * @param mixed $val
     */
    public function setSearchBatchSize($val)
    {
        $this->searchBatchSize = $val;
    }

    /**
     * Public API key. This MUST be used for all client-side URLs!
     * Allows read access to the API
     * @return mixed
     */
    public function getPublicApiKey()
    {
        return substr($this->apiKey, 0, 16);
    }
}
