<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Library\Semknox\Query;

use Semknox\Semknox\Library\Semknox\ApiCommunicator;

/**
 * Class ProductDelete
 *
 * Delete the products
 *
 * @package Semknox\Semknox\Library\Query
 */
class ProductsDelete
{

    /**
     * @var ApiCommunicator
     */
    protected $api;

    /**
     * ProductsPut constructor.
     *
     * @param ApiCommunicator $apiCommunicator
     */
    public function __construct(
        ApiCommunicator $apiCommunicator
    ) {
        $this->api = $apiCommunicator;
    }

    /**
     * Delete a single product
     *
     * @param int $articleNumber
     *
     * @return void
     */
    public function delete($articleNumber)
    {
        $this->api->requestDelete('products', [
            'articleNumber' => $articleNumber
        ]);
    }
}
