<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Config\Source;

/**
 * Class Environment
 * Option model for application environments
 *
 * @package Semknox\Semknox\Model\Config\Source
 */
class Environment implements \Magento\Framework\Option\ArrayInterface
{

    const ENV_STAGE_VALUE = 'stage';
    const ENV_STAGE_URL = 'https://stage-magento.semknox.com/';
    const ENV_LIVE_VALUE = 'live';
    const ENV_LIVE_URL = 'https://api-magento.semknox.com/';

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        return [
            ['value' => self::ENV_STAGE_VALUE, 'label' => __('SKNOX_Staging')],
            ['value' => self::ENV_LIVE_VALUE, 'label' => __('SKNOX_Production')]
        ];
    }
}
