<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\CategoryInterface;

class Category extends DataObject implements CategoryInterface
{
    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->_getData(self::VAR_NAME);
    }

    /**
     * @return mixed
     */
    public function getImage()
    {
        return $this->_getData(self::VAR_IMAGE);
    }

    /**
     * @param string $name
     * @return mixed
     */
    public function setName($name)
    {
        return $this->setData(self::VAR_NAME, $name);
    }

    /**
     * @param string $image
     * @return mixed
     */
    public function setImage($image)
    {
        return $this->setData(self::VAR_IMAGE, $image);
    }
}
