<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\Product\PriceInterface;
use Semknox\Semknox\Library\Semknox\Api\Data\ProductInterface;

class Product extends DataObject implements ProductInterface
{
    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->_getData(self::VAR_NAME);
    }

    /**
     * @return mixed
     */
    public function getImage()
    {
        return $this->_getData(self::VAR_IMAGE);
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->_getData(self::VAR_ID);
    }

    /**
     * @return mixed
     */
    public function getLink()
    {
        return $this->_getData(self::VAR_LINK);
    }

    /**
     * @return mixed
     */
    public function getPrice()
    {
        return $this->_getData(self::VAR_PRICE);
    }

    /**
     * @param string $name
     * @return mixed
     */
    public function setName($name)
    {
        return $this->setData(self::VAR_NAME, $name);
    }

    /**
     * @param string $image
     * @return mixed
     */
    public function setImage($image)
    {
        return $this->setData(self::VAR_IMAGE, $image);
    }

    /**
     * @param string $id
     * @return mixed
     */
    public function setId($id)
    {
        return $this->setData(self::VAR_ID, $id);
    }

    /**
     * @param string $link
     * @return mixed
     */
    public function setLink($link)
    {
        return $this->setData(self::VAR_LINK, $link);
    }

    /**
     * @param PriceInterface $price
     * @return $this
     */
    public function setPrice($price)
    {
        return $this->setData(self::VAR_PRICE, $price->toArray());
    }
}
