<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\Result\FlagInterface;
use Semknox\Semknox\Library\Semknox\Api\Data\ResultInterface;

class Result extends DataObject implements ResultInterface
{
    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->_getData(self::VAR_ID);
    }

    /**
     * @return mixed
     */
    public function getGroupId()
    {
        return $this->_getData(self::VAR_GROUP_ID);
    }

    /**
     * @return mixed
     */
    public function getArticleNumber()
    {
        return $this->_getData(self::VAR_ARTICLE_NUMBER);
    }

    /**
     * @return mixed
     */
    public function getProperties()
    {
        return $this->_getData(self::VAR_PROPERTIES);
    }

    /**
     * @return mixed
     */
    public function getPassOn()
    {
        return $this->_getData(self::VAR_PASS_ON);
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->_getData(self::VAR_NAME);
    }

    /**
     * @return mixed
     */
    public function getImage()
    {
        return $this->_getData(self::VAR_IMAGE);
    }

    /**
     * @return mixed
     */
    public function getLink()
    {
        return $this->_getData(self::VAR_LINK);
    }

    /**
     * @return mixed
     */
    public function getFeatured()
    {
        return $this->_getData(self::VAR_FEATURE);
    }

    /**
     * @return mixed
     */
    public function getHead()
    {
        return $this->_getData(self::VAR_HEAD);
    }

    /**
     * @return FlagInterface[]
     */
    public function getFlags()
    {
        return $this->_getData(self::VAR_FLAGS);
    }

    /**
     * @param int $id
     * @return $this
     */
    public function setId($id)
    {
        $this->setData(self::VAR_ID, $id);
        return $this;
    }

    /**
     * @param int $groupId
     * @return $this
     */
    public function setGroupId($groupId)
    {
        $this->setData(self::VAR_GROUP_ID, $groupId);
        return $this;
    }

    /**
     * @param int $articleNumber
     * @return $this
     */
    public function setArticleNumber($articleNumber)
    {
        $this->setData(self::VAR_ARTICLE_NUMBER, $articleNumber);
        return $this;
    }

    /**
     * @param mixed $properties
     * @return $this
     */
    public function setProperties($properties)
    {
        $this->setData(self::VAR_PROPERTIES, $properties);
        return $this;
    }

    /**
     * @param mixed $passOn
     * @return $this
     */
    public function setPassOn($passOn)
    {
        $this->setData(self::VAR_PASS_ON, $passOn);
        return $this;
    }

    /**
     * @param string $name
     * @return $this
     */
    public function setName($name)
    {
        $this->setData(self::VAR_NAME, $name);
        return $this;
    }

    /**
     * @param string $image
     * @return $this
     */
    public function setImage($image)
    {
        $this->setData(self::VAR_IMAGE, $image);
        return $this;
    }

    /**
     * @param mixed $link
     * @return $this
     */
    public function setLink($link)
    {
        $this->setData(self::VAR_LINK, $link);
        return $this;
    }

    /**
     * @param bool $featured
     * @return $this
     */
    public function setFeatured($featured)
    {
        $this->setData(self::VAR_FEATURE, $featured);
        return $this;
    }

    /**
     * @param bool $head
     * @return $this
     */
    public function setHead($head)
    {
        $this->setData(self::VAR_HEAD, $head);
        return $this;
    }

    /**
     * @param FlagInterface[] $flags
     * @return $this
     */
    public function setFlags($flags)
    {
        return $this->setData(self::VAR_FLAGS, $flags);
    }
}
