<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data\Result\Filter;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\Result\Filter\OptionInterface;

class Option extends DataObject implements OptionInterface
{
    /**
     * @return int
     */
    public function getId()
    {
        return $this->_getData(self::VAR_ID);
    }

    /**
     * @return int
     */
    public function getTemplateOptionId()
    {
        return $this->_getData(self::VAR_TEMPLATE_OPTION_ID);
    }

    /**
     * @return string
     */
    public function getIcon()
    {
        return $this->_getData(self::VAR_ICON);
    }

    /**
     * @return bool
     */
    public function getDefault()
    {
        return $this->_getData(self::VAR_DEFAULT);
    }

    /**
     * @return int
     */
    public function getPosition()
    {
        return $this->_getData(self::VAR_POSITION);
    }

    /**
     * @return int
     */
    public function getDelta()
    {
        return $this->_getData(self::VAR_DELTA);
    }

    /**
     * @return int
     */
    public function getCount()
    {
        return $this->_getData(self::VAR_COUNT);
    }

    /**
     * @return string
     */
    public function getViewName()
    {
        return $this->_getData(self::VAR_VIEW_NAME);
    }

    /**
     * @param int $id
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->setData(self::VAR_ID, $id);
        return $this;
    }

    /**
     * @param int $templateOptionId
     *
     * @return $this
     */
    public function setTemplateOptionId($templateOptionId)
    {
        $this->setData(self::VAR_TEMPLATE_OPTION_ID, $templateOptionId);
        return $this;
    }

    /**
     * @param string $icon
     *
     * @return $this
     */
    public function setIcon($icon)
    {
        $this->setData(self::VAR_ICON, $icon);
        return $this;
    }

    /**
     * @param bool $default
     *
     * @return $this
     */
    public function setDefault($default)
    {
        $this->setData(self::VAR_DEFAULT, $default);
        return $this;
    }

    /**
     * @param int $position
     *
     * @return $this
     */
    public function setPosition($position)
    {
        $this->setData(self::VAR_POSITION, $position);
        return $this;
    }

    /**
     * @param int $delta
     *
     * @return $this
     */
    public function setDelta($delta)
    {
        $this->setData(self::VAR_DELTA, $delta);
        return $this;
    }

    /**
     * @param int $count
     *
     * @return $this
     */
    public function setCount($count)
    {
        $this->setData(self::VAR_COUNT, $count);
        return $this;
    }

    /**
     * @param string $viewName
     *
     * @return $this
     */
    public function setViewName($viewName)
    {
        $this->setData(self::VAR_VIEW_NAME, $viewName);
        return $this;
    }
}
