<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data\Result;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\Result\FlagInterface;

class Flag extends DataObject implements FlagInterface
{

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->_getData(self::VAR_ID);
    }

    /**
     * @return mixed
     */
    public function getViewName()
    {
        return $this->_getData(self::VAR_VIEW_NAME);
    }

    /**
     * @return mixed
     */
    public function getIcon()
    {
        return $this->_getData(self::VAR_ICON);
    }

    /**
     * @return mixed
     */
    public function getValue()
    {
        return $this->_getData(self::VAR_VALUE);
    }

    /**
     * @param int $id
     * @return $this
     */
    public function setId($id)
    {
        return $this->setData(self::VAR_ID, $id);
    }

    /**
     * @param string $name
     * @return $this
     */
    public function setViewName($name)
    {
        return $this->setData(self::VAR_VIEW_NAME, $name);
    }

    /**
     * @param string $icon
     * @return $this
     */
    public function setIcon($icon)
    {
        return $this->setData(self::VAR_ICON, $icon);
    }

    /**
     * @param string $value
     * @return $this
     */
    public function setValue($value)
    {
        return $this->setData(self::VAR_VALUE, $value);
    }
}
