<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data\Result;

use Magento\Framework\DataObject;
use Semknox\Semknox\Library\Semknox\Api\Data\Result\OrderInterface;

class Order extends DataObject implements OrderInterface
{
    /**
     * @return mixed
     */
    public function getViewName()
    {
        return $this->_getData(self::VAR_VIEW_NAME);
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->_getData(self::VAR_ID);
    }

    /**
     * @return mixed
     */
    public function getRelation()
    {
        return $this->_getData(self::VAR_RELATION);
    }

    /**
     * @param string $id
     * @return $this
     */
    public function setId($id)
    {
        $this->setData(self::VAR_ID, $id);
        return $this;
    }

    /**
     * @param string $relation
     * @return $this
     */
    public function setRelation($relation)
    {
        $this->setData(self::VAR_RELATION, $relation);
        return $this;
    }

    /**
     * @param string $viewName
     * @return $this
     */
    public function setViewName($viewName)
    {
        $this->setData(self::VAR_VIEW_NAME, $viewName);
        return $this;
    }
}
