<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */

namespace Semknox\Semknox\Model\Data;

use Magento\Framework\DataObject;
use Magento\Search\Model\QueryFactory;
use Magento\Framework\UrlInterface;
use Magento\Framework\App\Request\Http as HttpRequest;
use Semknox\Semknox\Library\Semknox\Api\Data\SearchtermInterface;

class SearchTerm extends DataObject implements SearchtermInterface
{
    /** @var \Magento\Framework\UrlInterface  */
    protected $urlBuilder;

    /** @var HttpRequest  */
    protected $request;

    /**
     * SearchTerm constructor.
     * @param UrlInterface $urlBuilder
     * @param HttpRequest $request
     * @param array $data
     */
    public function __construct(
        UrlInterface $urlBuilder,
        HttpRequest $request,
        array $data = []
    ) {
        $this->urlBuilder = $urlBuilder;
        $this->request = $request;
        parent::__construct($data);
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->_getData(self::VAR_NAME);
    }

    /**
     * @return mixed
     */
    public function getLink()
    {
        return $this->_getData(self::VAR_LINK);
    }

    /**
     * @param string $name
     * @return mixed
     */
    public function setName($name)
    {
        $link = $this->urlBuilder->getUrl(
            'catalogsearch/result',
            ['_query' => [QueryFactory::QUERY_VAR_NAME => $name], '_secure' => $this->request->isSecure()]
        );
        $this->setData(self::VAR_LINK, $link);
        return $this->setData(self::VAR_NAME, $name);
    }
}
