<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Observer\CatalogSearch\Result\Index;

use Magento\Framework\Event\ObserverInterface;
use Semknox\Semknox\Helper\ConfigInterface;

class Robots implements ObserverInterface
{

    /**
     * @var ConfigInterface
     */
    protected $searchConfig;

    /**
     * @var \Magento\Framework\View\Page\Config
     */
    protected $pageConfig;

    /**
     * Robots constructor.
     *
     * @param ConfigInterface                     $searchConfig
     * @param \Magento\Framework\View\Page\Config $pageConfig
     */
    public function __construct(
        ConfigInterface $searchConfig,
        \Magento\Framework\View\Page\Config $pageConfig
    ) {

        $this->searchConfig = $searchConfig;
        $this->pageConfig = $pageConfig;
    }

    /**
     * Change the robots (NO)INDEX,(NO)FOLLOW meta tag.
     * @param \Magento\Framework\Event\Observer $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        if ($observer->getEvent()->getFullActionName() == 'catalogsearch_result_index'
            && !$this->searchConfig->getAreRobotsAllowedOnSearchResults()) {
            $this->pageConfig->setRobots('NOINDEX,NOFOLLOW');
        }
    }
}
