<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2019 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Plugin\Block\Product\ProductList;

use Magento\Framework\App\Helper\Context;
use Magento\Framework\Controller\ResultInterface;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Stdlib\StringUtils;
use Magento\Search\Model\QueryFactory;
use Semknox\Semknox\Helper\ApiConnection;
use Semknox\Semknox\Helper\ConfigInterface;

/**
 * Class Toolbar
 *
 * Sets the order by relevance after setting a custom order with the search backend (because order is
 * done by backend and relevance is actually the order we want).
 *
 * @package Semknox\Semknox\Plugin\Block\Product\ProductList
 */
class Toolbar
{

    public function afterSetCollection(\Magento\Catalog\Block\Product\ProductList\Toolbar $subject)
    {
        if (strpos($subject->getCurrentOrder(), ApiConnection::PREFIX_SEARCH_RESULT_ORDER) === 0) {
            $subject->getCollection()->setOrder('relevance', 'DESC');
        }
        return $subject;
    }
}
