<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Plugin\CatalogSearch\Controller\Advanced;

use Magento\Framework\Controller\Result\ForwardFactory;
use Magento\Framework\Controller\ResultInterface;

/**
 * Class Index
 *
 * Redirect advanced search to no-route, because it is not supported with this module
 *
 * @package Semknox\Semknox\Plugin\CatalogSearch\Controller\Advanced
 */
class Index
{

    /**
     * @var ForwardFactory
     */
    protected $resultForwardFactory;

    /**
     * Index constructor.
     *
     * @param ForwardFactory $resultForwardFactory
     */
    public function __construct(
        ForwardFactory $resultForwardFactory
    ) {
        $this->resultForwardFactory = $resultForwardFactory;
    }

    /**
     * @param \Magento\CatalogSearch\Controller\Advanced\Index $subject
     * @param callable                                         $proceed
     * @return ResultInterface|null
     */
    public function aroundExecute(\Magento\CatalogSearch\Controller\Advanced\Index $subject, callable $proceed)
    {
        /** @var \Magento\Framework\Controller\Result\Forward $resultForward */
        $resultForward = $this->resultForwardFactory->create();
        return $resultForward->forward('noroute');
    }
}
