<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */

namespace Semknox\Semknox\Plugin\Indexer\Stock;

use Magento\CatalogInventory\Model\Stock\Item as OriginalItem;
use Semknox\Semknox\Service\IndexerService;

class Item
{

    /** @var IndexerService */
    protected $indexerService;

    /**
     * @param IndexerService $indexerService
     */
    public function __construct(
        IndexerService $indexerService
    ) {
        $this->indexerService = $indexerService;
    }

    /**
     * Reindex when a stock item is changed
     *
     * @param OriginalItem $item
     * @param \Closure     $proceed
     *
     * @return mixed
     */
    public function aroundSave(OriginalItem $item, \Closure $proceed)
    {
        $result = $proceed();
        $this->indexerService->execute($item->getProductId());
        return $result;
    }
}
