<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */

namespace Semknox\Semknox\Service\Converter;

/**
 * Class ProductConverter
 *
 * Converts a product model to an array compliant to the Search Service API.
 *
 * @package Semknox\Semknox\Service
 */
interface ProductConverterInterface
{

    /**
     * Convert a single product to Search Service compatible data.
     *
     * @param int $productId
     * @param int $storeId
     *
     * @return array A Search Service-API compliant product data array
     */
    public function execute($productId, $storeId);
}
