<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Service\InitialUpload;

/**
 * Class ScheduleInterface
 *
 * The schedule of steps in the upload process, may be overwriten by Search Service Plugins
 */
interface ScheduleInterface
{
    /**
     * An array of tasks, in the format:
     *  [weight => <weight in progress bar, sum has to be 100>,
     *   key => <runner state key>,
     *   factory => <Task Factory Class>]
     * WAITING is always the first task and it will then transition to the first task in this list.
     *
     * Can NOT be empty
     *
     * @return array
     */
    public function getSchedule();
}
