<?php
/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */

namespace Semknox\Semknox\Service\InitialUpload;

use Semknox\Semknox\Helper\InitialUpload\InfoHelperInterface;

interface TaskInterface
{

    /**
     * Perform the initial upload process task
     *
     * @param InfoHelperInterface $uploadInfoHelper
     *
     * @return mixed
     */
    public function execute($uploadInfoHelper);

    /**
     * This function get's called before the task is run for the first time in an upload process
     *
     * @param InfoHelperInterface $uploadInfoHelper
     *
     * @return void
     */
    public function taskStart($uploadInfoHelper);

    /**
     * This function get's called after the task is run for the last time in an upload process
     *
     * @param InfoHelperInterface $uploadInfoHelper
     *
     * @return void
     */
    public function taskEnd($uploadInfoHelper);
}
