<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Test\Unit\Library;

use Semknox\Semknox\Library\LibSearch;
use Semknox\Semknox\Library\Semknox\SemknoxApi;

class LibSearchTest extends \PHPUnit\Framework\TestCase
{

    /**
     * @var \PHPUnit_Framework_MockObject_MockObject|SemknoxApi
     */
    protected $semknoxApiMock;

    /**
     * @var LibSearch
     */
    protected $search;

    /**
     * @var \PHPUnit_Framework_MockObject_MockObject|\Semknox\Semknox\Library\SearchResult\LibSearchResult
     */
    protected $libSearchResult;

    /**
     * Setup classes
     * @return void
     */
    public function setUp()
    {
        $objectManager = new \Magento\Framework\TestFramework\Unit\Helper\ObjectManager($this);

        $this->semknoxApiMock = $this->getMockBuilder('\Semknox\Semknox\Library\Semknox\SemknoxApi')
            ->disableOriginalConstructor()->getMock();

        $this->libSearchResult = $this->getMockBuilder('\Semknox\Semknox\Library\SearchResult\LibSearchResult')
            ->disableOriginalConstructor()->getMock();

        $libSearchResultFactory = $this->getMockBuilder('\Semknox\Semknox\Library\SearchResult\LibSearchResultFactory')
            ->disableOriginalConstructor()
            ->setMethods(['create'])
            ->getMock();
        $libSearchResultFactory->expects(self::any())
            ->method('create')
            ->willReturn($this->libSearchResult);

        $this->search = $objectManager->getObject(
            '\Semknox\Semknox\Library\LibSearch',
            [
                'semknoxApi'                => $this->semknoxApiMock,
                'libSearchResultFactory'    => $libSearchResultFactory
            ]
        );
    }

    /**
     * @return void
     */
    public function testGetProducts()
    {
        $query = random_int(0, 100);
        $filters = random_int(0, 100);
        $rangeFilters = random_int(0, 100);
        $order = random_int(0, 100);
        $dir = random_int(0, 100);

        $this->semknoxApiMock->expects(self::once())
            ->method('getProducts')
            ->with($query, $filters, $rangeFilters, $order, $dir);

        $this->search->getProducts($query, $filters, $rangeFilters, $order, $dir);
    }
}
