<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */
namespace Semknox\Semknox\Test\Unit\Library\Semknox\Query;

use Semknox\Semknox\Library\Semknox\ApiCommunicatorFactory;
use Semknox\Semknox\Library\Semknox\ApiConfig;

class ApiCommunicatorFactoryTest extends \PHPUnit\Framework\TestCase
{

    /**
     * @var ApiConfig
     */
    protected $credentialsMock;

    /**
     * @var ApiCommunicatorFactory
     */
    protected $factory;

    /**
     * Test setup
     * @return void
     */
    public function setUp()
    {

        $this->credentialsMock = $userCredentialsMock =
            $this->getMockBuilder(
                '\Semknox\Semknox\Library\Semknox\ApiConfig'
            )
            ->disableOriginalConstructor()->getMock();

        $this->factory = new ApiCommunicatorFactory();
    }

    /**
     * @covers \Semknox\Semknox\Library\ApiCommunicatorFactory::create
     * @return void
     */
    public function testCreate()
    {
        $this->assertInstanceOf(
            '\Semknox\Semknox\Library\Semknox\ApiCommunicator',
            $this->factory->create($this->credentialsMock)
        );
    }
}
