<?php
/**
 * SEMKNOX API - PHP Library
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Marco Köpcke <marco.koepcke@tudock.de>
 */

namespace Semknox\Semknox\Test\Unit\Library\Semknox\Test\Query;

use Semknox\Semknox\Library\Semknox\Query\ProductsDelete;

class ProductsDeleteTest extends \PHPUnit\Framework\TestCase
{

    /**
     * @var ProductsDelete
     */
    protected $productsDelete;

    /**
     * @var \Semknox\Semknox\Library\Semknox\ApiCommunicator|\PHPUnit_Framework_MockObject_MockObject
     */
    protected $apiMock;

    /**
     * @var int
     */
    protected $productId;

    /**
     * Setup
     *
     * @return void
     */
    public function setUp()
    {

        $this->productId = 1337;

        $this->apiMock = $this->getMockBuilder('\Semknox\Semknox\Library\Semknox\ApiCommunicator')
            ->disableOriginalConstructor()
            ->getMock();

        $this->productsDelete = new ProductsDelete(
            $this->apiMock
        );
    }

    /**
     * @return void
     */
    public function testDelete()
    {
        $this->apiMock->expects(self::once())
            ->method('requestDelete')
            ->with('products', [
                'articleNumber' => $this->productId
            ]);

        $this->productsDelete->delete($this->productId);
    }
}
