define([
    "jquery",
    "jquery/ui",
    "Magento_Catalog/js/product/list/toolbar"
], function($) {
    /**
     * Override widget to send location changes to pjax.
     */
    $.widget('mage.productListToolbarForm', $.mage.productListToolbarForm, {
        changeUrl: function (paramName, paramValue, defaultValue) {
            var decode = window.decodeURIComponent;
            var urlPaths = this.options.url.split('?'),
                baseUrl = urlPaths[0],
                urlParams = urlPaths[1] ? urlPaths[1].split('&') : [],
                paramData = {},
                parameters;
            for (var i = 0; i < urlParams.length; i++) {
                parameters = urlParams[i].split('=');
                paramData[decode(parameters[0])] = parameters[1] !== undefined
                    ? decode(parameters[1].replace(/\+/g, '%20'))
                    : '';
            }
            paramData[paramName] = paramValue;
            if (paramValue == defaultValue) {
                delete paramData[paramName];
            }
            paramData = $.param(paramData);

            // TUDOCK++ : Send URL to PJAX if available
            var finalUrl = baseUrl + (paramData.length ? '?' + paramData : '');
            if (typeof $.pjax == 'function') {
                $.pjax({url: finalUrl, container: 'body', timeout: 25000});
            } else {
                location.href = finalUrl;
            }
        }
    });

    return $.mage.productListToolbarForm;
});
