/**
 * SEMKNOX Magento 2 Module
 *
 * @copyright   Copyright (c) 2017 Tudock GmbH (http://www.tudock.de)
 * @author      Artsiom Bruneuski <artsiom.bruneuski@tudock.de>
 */
define([
    "jquery",
    "jquery-ui"
], function ($) {
    'use strict';

    $.widget('mage.tudockSlider', {
        slider: null,
        from: null,
        to: null,
        apply: null,
        options: {},
        _create: function() {
            this.slider = this.element.find('[slider-data-id=slider]').slider({
                range: true,
                step: 0.1,
                min: this.options.min,
                max: this.options.max,
                values: this.options.values,
                slide: this.slide.bind(this)
            });

            this.from = this.element.find('[slider-data-id=from]');
            this.to = this.element.find('[slider-data-id=to]');
            this.apply = this.element.find('[slider-data-id=apply]');

            this.syncControls(this.options.values);

            this.apply.on('click', this.redirect.bind(this));
            this.from.on('change', this.syncSlider.bind(this));
            this.to.on('change', this.syncSlider.bind(this));

            this.element.on('keypress', this.keypress.bind(this));
        },
        keypress: function(e) {
            var key = e.which;
            if(key == 13)  // the enter key code
            {
                this.apply.trigger('click');
                return false;
            }
        },
        slide: function (event, ui) {
            this.syncControls(ui.values);
        },
        syncControls: function (values) {
            this.from.val(values[0]);
            this.to.val(values[1]);
        },
        syncSlider: function () {
            this.slider.slider('values', [this.from.val(), this.to.val()]);
        },
        redirect: function() {
            if ($.isNumeric(this.from.val()) && $.isNumeric(this.to.val())) {
                var params = encodeURIComponent(this.from.val() + ',' + this.to.val());
                var url = this.options.url.replace('from_to', params);
                this.apply.attr('href', url);
            }
        }
    });

    return $.mage.tudockSlider;
})